# !/bin/sh
UIMAGE=$1/uImage
ROOTFS=$1/rootfs.jffs2
USERDIR=$1/userfs
LOGDIR=/tmp

LOGFILE=$LOGDIR/update-`date +"%Y%m%d-%H%M%S"`.log

sync

cd /tmp/

# redirect stdxxx to LOGFILE
exec > $LOGFILE 2>&1

echo "copying tools to /tmp..."
cp /bin/busybox /tmp/
cp /usr/sbin/nandwrite /tmp/

# Should do things according to current running version
VER=`awk '/^BSP version/ { split($NF, v, "."); print v[1]*10000+v[2]*100+v[3] }' /proc/boardinfo`
if [ $VER -lt 20400 ]; then
	cp /usr/sbin/flash_eraseall /tmp/
else
	cp /usr/sbin/flash_erase /tmp/
	echo "#!/bin/sh" > /tmp/flash_eraseall
	echo '/tmp/flash_erase $1 0 0' >> /tmp/flash_eraseall
	chmod +x /tmp/flash_eraseall
fi

echo "update dir is $1"

echo "start copying user files..."
for f in `ls $USERDIR`; do
	echo "- copying $f..."
	cp -f $USERDIR/$f /mnt/user
done
echo "user files copied."

sync & sync & sync
#umount /dev/mtdblock1
#/bin/umount /

if [ ! -x ./flash_eraseall ]; then
	echo "./flash_eraseall not found !"
	exit 1
fi

date
echo "start erasing flash..."
if [ -f $UIMAGE ]; then
	echo "erasing /dev/mtd1..."
	./flash_eraseall /dev/mtd1
	echo "/dev/mtd1 erased."
fi
if [ -f $ROOTFS ]; then
	echo "unmounting root partition..."
	umount /
	echo "erasing /dev/mtd2..."
	./flash_eraseall /dev/mtd2
	echo "/dev/mtd2 erased."
fi
./busybox date
echo "done"

./busybox date
echo "start flashing... "
if [ -f $UIMAGE ]; then
	echo "flashing /dev/mtd1 with $UIMAGE..."
	./nandwrite -p /dev/mtd1 $UIMAGE
	echo "/dev/mtd1 flashed with $UIMAGE."
fi
if [ -f $ROOTFS ]; then
	echo "flashing /dev/mtd2 with $ROOTFS"
	./nandwrite -p /dev/mtd2 $ROOTFS
	echo "/dev/mtd2 flashed with $ROOTFS."
fi

./busybox date
echo "done"

echo "rebooting..."

./busybox reboot

exit 0
